{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uDataModuleUnidadesMedida;

interface

uses
  SysUtils, Classes, DB, uDADataTable, uDABINAdapter,
  uDAScriptingProvider, uDACDSDataTable, uROWinInetHttpChannel, uROTypes,
  uRORemoteService, uROClient, uROBinMessage,
  uDADesigntimeCall,

  uIDataModuleUnidadesMedida, uBizUnidadesMedida, uDADataStreamer, uDARemoteDataAdapter,
  uDAInterfaces, uRODynamicRequest, uDABin2DataStreamer, uDAMemDataTable,
  uDataModuleBase;

type
  TDataModuleUnidadesMedida = class(TDataModuleBase, IDataModuleUnidadesMedida)
    RORemoteService: TRORemoteService;
    rda_UnidadesMedida: TDARemoteDataAdapter;
    Bin2DataStreamer: TDABin2DataStreamer;
    tbl_UnidadesMedida: TDAMemDataTable;
    ds_UnidadesMedida: TDADataSource;
    procedure DAClientDataModuleCreate(Sender: TObject);
  public
    function GetItems: IBizUnidadMedida;
    function GetItem(const ID : Integer) : IBizUnidadMedida;
    function NewItem : IBizUnidadMedida;
  end;

implementation

{$R *.DFM}

uses
  FactuGES_Intf, uDataModuleConexion, uDataTableUtils, cxControls, 
  schUnidadesMedidaClient_Intf;

{ TDataModuleUnidadesMedida }

procedure TDataModuleUnidadesMedida.DAClientDataModuleCreate(Sender: TObject);
begin
  RORemoteService.Channel := dmConexion.Channel;
  RORemoteService.Message := dmConexion.Message;
end;

function TDataModuleUnidadesMedida.GetItems: IBizUnidadMedida;
var
  AUnidadMedida : TDAMemDataTable;
begin
  ShowHourglassCursor;
  try
    AUnidadMedida := CloneDataTable(tbl_UnidadesMedida);
    AUnidadMedida.BusinessRulesID := BIZ_CLIENT_UnidadMedida;

    Result := (AUnidadMedida as IBizUnidadMedida);
  finally
    HideHourglassCursor;
  end;
end;

function TDataModuleUnidadesMedida.NewItem: IBizUnidadMedida;
begin
  Result := GetItem(ID_NULO)
end;

function TDataModuleUnidadesMedida.GetItem(const ID: Integer): IBizUnidadMedida;
var
  Condicion: TDAWhereExpression;
begin
  ShowHourglassCursor;
  try
    Result := Self.GetItems;

    with Result.DataTable.DynamicWhere do
    begin
      // (ID = :ID)
      Condicion := NewBinaryExpression(NewField('', fld_UnidadesMedidaID), NewConstant(ID, datInteger), dboEqual);

      if IsEmpty then
         Expression := Condicion
      else
         Expression := NewBinaryExpression(Expression, Condicion, dboAnd);
    end;

  finally
    HideHourglassCursor;
  end;
end;

end.
